Attribute VB_Name = "Direct3D_IMMODE"
Option Explicit

Public Dx As New DirectX7
Public Dd As DirectDraw4
Public Primary As DirectDrawSurface4
Public Back_Buffer As DirectDrawSurface4
Public Ddsd As DDSURFACEDESC2

Public D3d As Direct3DRM3
Public Device As Direct3DRMDevice3
Public ViewPort As Direct3DRMViewport2
Dim Light As Direct3DRMLight
Dim Shadow As Direct3DRMLight

Public WorldFrame As Direct3DRMFrame3
Public CameraFrame As Direct3DRMFrame3
Public LightFrame As Direct3DRMFrame3

Public Const PI  As Single = 22 / 7
Public Const RAD As Single = PI / 180

Sub CreateD3DRM(Width As Long, Height As Long, Bpp As Long)
Set Dd = Dx.DirectDraw4Create("")
Dd.SetCooperativeLevel Form1.hWnd, DDSCL_ALLOWREBOOT Or DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN
Dd.SetDisplayMode Width, Height, 16, 0, DDSDM_DEFAULT

Ddsd.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
Ddsd.ddsCaps.lCaps = DDSCAPS_3DDEVICE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP Or DDSCAPS_PRIMARYSURFACE
Ddsd.lBackBufferCount = 1

Set Primary = Dd.CreateSurface(Ddsd)
Ddsd.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
Set Back_Buffer = Primary.GetAttachedSurface(Ddsd.ddsCaps)

Set D3d = Dx.Direct3DRMCreate
Set Device = D3d.CreateDeviceFromSurface("IID_IDirect3DHALDevice", Dd, Back_Buffer, D3DRMDEVICE_DEFAULT)

Device.SetBufferCount 2
Device.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_GOURAUD
Device.SetTextureQuality D3DRMTEXTURE_NEAREST
Device.SetRenderMode D3DRMRENDERMODE_BLENDEDTRANSPARENCY

Set WorldFrame = D3d.CreateFrame(Nothing)
Set CameraFrame = D3d.CreateFrame(WorldFrame)
Set LightFrame = D3d.CreateFrame(WorldFrame)
WorldFrame.SetSceneBackgroundRGB 0, 0, 0

Set Light = D3d.CreateLightRGB(D3DRMLIGHT_AMBIENT, 1, 1, 1)
Set Shadow = D3d.CreateLightRGB(D3DRMLIGHT_POINT, 2, 2, 2)
LightFrame.AddLight Light
LightFrame.AddLight Shadow

Set ViewPort = D3d.CreateViewport(Device, CameraFrame, 0, 0, Width, Height)
ViewPort.SetBack 1000
End Sub
Sub Unload_App()
On Error Resume Next
Set Dx = Nothing
Set Dd = Nothing
Set Primary = Nothing
Set Back_Buffer = Nothing

Set D3d = Nothing
Set Device = Nothing
Set WorldFrame = Nothing
Set CameraFrame = Nothing
Set LightFrame = Nothing
Set ViewPort = Nothing
End
End Sub
